From f32ed21ffa69cd866f249b3227e1dbc5e8892c89 Mon Sep 17 00:00:00 2001
From: Claude Heiland-Allen <claude@mathr.co.uk>
Date: Thu, 20 Sep 2018 21:05:12 +0100
Subject: [PATCH 21/39] [args] to ignore initbang messages (loadbang 1)

---
 src/classes2.cxx | 5 ++++-
 src/gridflow.cxx | 7 +------
 2 files changed, 5 insertions(+), 7 deletions(-)

diff --git a/src/classes2.cxx b/src/classes2.cxx
index 75e89747..444cbe6d 100644
--- a/src/classes2.cxx
+++ b/src/classes2.cxx
@@ -109,7 +109,10 @@ static void dont_handle_parens (int ac, t_atom2 *av) {for (int i=0; i<ac; i++) i
 			if (j-k) pd_anything2((t_pd *)t->te_inlet,j-k,av+k);
 		}
 	}
-	\decl 0 loadbang () {if (!noloadbang) _0_bang();}
+	\decl 0 loadbang (float f) {
+		if (f == 1/*LB_INIT*/) { /* ignore initbang */ }
+		if (f == 0/*LB_LOAD*/) if (!noloadbang) _0_bang();
+	}
 	void process_args (int argc, t_atom *argv) {
 		t_canvas *canvas = canvas_getrootfor(mom);
 		t_symbol *wildcard = gensym("*");
diff --git a/src/gridflow.cxx b/src/gridflow.cxx
index 4833fdd6..72fc901c 100644
--- a/src/gridflow.cxx
+++ b/src/gridflow.cxx
@@ -613,11 +613,6 @@ struct BFProxy : t_object {
 static t_class *BFProxy_class;
 static t_symbol *s_loadbang;
 
-static void BFObject_loadbang (BFObject *bself) {
-    try {FMethod m = method_lookup(bself,0,s_loadbang); m(bself->self,0,0);}
-    catch (Barf &oozy) {oozy.error(bself,0,s_loadbang);}
-}
-
 static void BFObject_anything (BFObject *bself, int winlet, t_symbol *s, int ac, t_atom2 *at) {
     #ifdef DES_BUGS
 	post("BFObject_anything bself=%08lx magic=%08lx self=%08lx",long(bself),bself->magic,long(bself->self));
@@ -867,7 +862,7 @@ void install2(FClass *fc, const char *name, int ninlets, int noutlets, int flags
 	//class_addblob(bc,t_method(BFObject_blob0));
 // loadbang has to be explicitly registered, because it is called by zgetfn.
 	FMethod m = method_lookup(fc,0,s_loadbang);
-	if (m) class_addmethod(bc,t_method(BFObject_loadbang),s_loadbang,A_NULL);
+	if (m) class_addmethod(bc,t_method(BFObject_anything0),s_loadbang,A_GIMME,0);
 }
 
 //static inline const t_atom &convert(const t_atom &x, const t_atom *foo) {return x;}
-- 
2.19.1

